Release Notes

HP Server Automation, Ultimate Edition

Software version: 10.20
Original Publication Date: December 12, 2014

Introduction

This document provides an overview of the HP Server Automation 10.20 release. It contains important information not included in the manuals or in the online help.

Up-To-Date Documentation

All the documentation is available from the new SA 10.x Documentation Library. See the section Documentation Information for instructions on how to use the Documentation Library to access the guides and white papers relevant to this release.

For the most updated release notes, see the SA 10.2 Release Notes on the HP Support website.

Audience

SA release notes contain information for users who are familiar with the installation and maintenance of SA, Storage Visibility and Automation, SE Connector, Application Deployment Manager, and DMA integration. The notes contain information that is not included in books or online Help.


Table of Contents

What's New in This Release
Post-Installation / Upgrade Tasks
Documentation Information
Deprecation Announcements
Known Issues
HP Software Support
Installation
Fixed Issues
Legal Notices

What's New In this Release

This section describes new functionality and other relevant release-specific information.

For information about what was new in previous releases, use your HP Passport Credentials to log in to the  HPSW Support Portal and use the Search button to search for a specific release-note document.

Important: SA 10.20 uses OpenSSL 1.0.1i, and, as a result, is not susceptible to the Heartbleed or Man in the Middle vulnerabilities.


What's New for All Qualified Managed Platform Support/OS Systems Support

SA Client Support for Windows Operating Systems

This section lists the operating-systems supported on the SA Client.

SA Managed Platform Support for Additional Operating Systems

Support and Compatibility Information

For complete SA support and compatibility information for this release, see the  HP Server Automation Support and Compatibility Matrix .

For a list of supported operating systems and platforms for Storage Visibility and Automation Managed Servers, SE Connector, SAN Arrays, Fibre Channel Adapters, SAN Switches, File System Software, Database Support, and Storage Essentials Compatibility, see the Storage Visibility and Automation Support and Compatibility Matrix.

For more information about supported configurations, see SA 10.20 Installation Guide, chapter 2: “SA Core Configurations Supported For Customer Installation”.

Back to the Table of Contents


What's New for SA Agents

Important: See Deprecation and End-of-Support Announcements for important SA Agent version deprecations and end-of-support announcements.

See Post-Installation/Upgrade Tasks for the SA Agent upgrade requirement.

SA Agent Installation

SA 10.20 supports SA Agent installation on IPv6.

For information on the Agent Upgrade tool, on installing the agent, and on bringing servers under SA management, see the SA User Guide: Server Automation.

SA Agent for FIPS Enablement

This SA version continues support for enabling FIPS at installation, and also supports enabling FIPS status through the Core Recertification process.  In order to support FIPS enablement, your SA Agent version must be SA 10.1 or higher.

SA Agent and IPv6 Support

This SA version supports the following for the SA Agent:

For more information on SA Agents, see the SA Administration Guide (in the SA 10.x Documentation Library).

Back to the Table of Contents


What's New for APIs

Software Policy Ordering

The following methods of com.opsware.swmgmt.PolicyAttachable now return the software policies ordered by name:

The policies naming scheme becomes a basic mechanism to control the order in which software policies are remediated within a job.

As a consequence the following API methods now remediate the software policies ordered alphanumerically:

Remediation Order of Policies

The following methods were updated to maintain the remediation order of policies as expressed by the first argument.

OS build plan flow control

The following methods have update input parameters:

The com.opsware.osprov.OSBuildPlanJobParams was updated so OS build plan flow control configuration can be checked/set:

Core Recert Service

The method startCoreRecertSetup takes the argument CoreRecertSetupJobArgument. This object has changed to include the following methods:

Other changes

Removed or Deprecated APIs


What's New for Audit

You can now perform the following audit-related actions for ESXi servers:

Your ESXi servers must be managed by a vCenter that has PowerShell and PowerCLI installed.

For more information on Audits, see the SA User Guide: Audit and Compliance.


What's New for Database and Middleware Automation

Database and Middleware Automation (HP DMA) is no longer installed as part of Server Automation. Starting with HP DMA version 10.00, HP DMA is available as a separate product with its own installation media. HP DMA 10.0x is still integrated with Server Automation, however. For more information, see the HP DMA Installation Guide.

Back to the Table of Contents


What's New for Localization

SA 10.20 has been localized to Simplified Chinese, Japanese, German, Russian, French, and Spanish.


What's New for OO-SA Integration

Updates pertaining specifically to the OO-SA integration (Server Automation operations performed within Operations Orchestration) are delivered via the HP Live Network.

For more information on SA integration, see the SA Integration Guide.

What's New for Oracle Database and Model Repository

SA 10.2 supports Oracle 12C RAC.

Back to the Table of Contents


What's New for Provisioning

New Features

Legacy syntax for hpsa_netconfig custom attribute deprecated

Use the new JSON-based syntax to specify configuration values for the hpsa_netconfig custom attribute. Refer to the  User Guide: Provisioning for details.

Support for provisioning of Windows 2003 deprecated

Support for provisioning of Windows 2003 with build plans has been removed.

OS Sequences Deprecated

The following types of OS Sequences are deprecated:

Instead of OS Sequences, use Build Plans for new provisioning jobs.

For more information on Provisioning, see the User Guide: Provisioning.


What's New for Patching

Performance Improvements

Minor Enhancements

SLES Patching is now performed using the SLES native package manager Zypper on SLES 11 GA or later, replacing yum.

For more information on patching, see the User Guide: Server Patching.

Back to the Table of Contents


What's New for Software Management

Support native tool for remediation on SLES 11

SA now supports Zypper as the package manager used by remediation jobs on SLES 11 GA or later.

For more information on SLES 11 remediation process, see the  User Guide: Software Management.

Viewing package contents for DEB packages

It is now possible to view the package contents for Ubuntu (DEB) packages, similarly to the functionality already available for RPM and ZIP packages.

For more information, see Viewing Package Contents in the User Guide: Software Management.

Back to the Table of Contents


What’s New for Virtualization Management

New features

  For more information on virtualization, see the User Guide: Virtualization Management.

Back to the Table of Contents


Deprecation and End-of-Support Announcements

This section lists deprecated platforms, features, and agents for this release as well as previously deprecated items that have now reached the end of their support lifecycle.

When a platform/agent/feature is identified as deprecated for a release, it means that you (the SA customer) are considered notified of its future removal. Deprecated features are still fully supported in the release they are deprecated in, unless specified otherwise. The intent is that deprecated features or platforms will have support removed in the next major or minor SA release; however, eventual removal is at the discretion of HP.

Managed Platforms

The following platforms are deprecated as of SA 10.0:

SA Agent Deprecation and Upgrade Requirement

SA 10.20 no longer supports SA Agents associated with SA 9.10 or earlier versions. Therefore, at a minimum, any SA Agents with version 9.10 or earlier must be upgraded to an SA Agent that is version 9.11 or later. 

See the Upgrade Guide for instructions on upgrading your SA Agents.

Agent Upgrade Tool

The Agent Upgrade Tool that is run from the OPSH shell and allows upgrading the agents on managed servers was deprecated. As of SA 10.0, a replacement APX was introduced that has several improvements and can be run from the SA Client.

Deprecated API Methods

The following API methods were removed following the move of application configurations into folder in SA 9.0:

BSAE Reporting Removed

Business Service Automation Essentials (BSAE) Reporting was removed in SA 10.1. It has been replaced by the Automation Insight (AI) product.

See Automation Insight (AI) documentation for details.

SA Web Client is Deprecated

The SA Web Client is being deprecated.  The majority of retained features have been ported to the SA Client (NGUI). 

OS Provisioning OS Sequences are Deprecated

OS Sequences are being replaced by OS Build Plans.  See the  User Guide: Provisioning for instructions.

Embedded Reports are Deprecated

The Embedded Reports feature is deprecated as of SA 10.1.

Unsupported Platforms

The following platforms are no longer supported as of SA 10.0:

Unsupported Features

Legacy Job Types No Longer Supported New Replacement Job Types
Clone Virtual Machine (VMware) Clone Virtual Machine
Create Virtual Machine (Hyper-V)
Create Virtual Machine (VMware)
Create Virtual Machine
Delete Virtual Machine (Hyper-V)
Remove Virtual Machine
Delete Virtual Machine
Modify Virtual Machine
Modify Virtual Machine (Hyper-V)
Modify Virtual Machine

Note:  Any scheduled or blocked jobs of the legacy job types will be marked as Deleted during migration.

Unsupported Scripts

As of SA 7.80, the following scripts are no longer supported:

Starting In SA 9.0, you must use the unified start script:

/etc/init.d/opsware-sas

If you have any applications or scripts that depend on this script, you must rewrite them to use the unified start script.

Back to the Table of Contents


Installation

See the  Installation Guide for installation instructions.

Adobe Flash Player and SA Client Launcher Issues

Certain SA Client features (such as Run OS Build Plan or HP UX Provisioning) require the Adobe Flash Player. If you try to run these features, and you have not yet installed Adobe Flash Player, you will get an error.

To make sure Adobe Flash Player functions correctly and to avoid the error message, you should:

  1. Access the  Adobe Flash Player and follow the instructions to download the latest Adobe Flash Player.
  2. Restart the SA client.
The SA Client Launcher has been updated in this release. Users who have a previous version of the launcher installed will receive a warning message, and will be required to reinstall the latest version.

Follow these steps to install the new launcher:

  1. Exit all instances of the SA Client (check your TaskManager to ensure that all instances are stopped).
  2. Uninstall the HP SA Client Launcher.
  3. Download the HP SA Client Launcher (1.7.4 or later):
    1. Access the SA Web Client login page and download the new launcher, or
    2. Login to the SA Web Client and download the installer from the right panel in the home page.
  4. Reinstall the HP SA Client Launcher.
  5. Restart the SA Client and run the features normally.

Back to the Table of Contents


Post-Installation / Upgrade Tasks

This section lists the tasks that should be performed after you install or upgrade to SA 10.20. Some tasks might not be appropriate for your situation.

Windows Server Command-Line Interface Installation

If you plan to install the SA Command-line Interface (OCLI) on a Windows Server after upgrading to SA 10.20, you must update the SA Agent on that server to the latest version. Errors occur during OCLI installation on Windows servers with earlier SA Agent versions.

Install an SA 10.20 Core, or upgrade to an SA 10.20 Core Without Enabling root SSH Login

New Users

The following new users are supported when using the SA installer to install, or upgrade SA on the local machine:

Note: When you use a regular user for performing the installation or upgrade of a core, make sure you invoke the command using sudo.
For example: sudo <distro>/ opsware_installer/hpsa_install.sh

The following new users are supported when using the SA installer to install SA on remote machines:

WARNING: Password-less sudo is not supported for regular users with sudo capabilities.

 
Settings Required for Regular Users with sudo Capabilities

Make the following changes to the /etc/sudoers file on every machine where the user (in this case bob) installs SA:

General Settings for User Names

This section describes general rules for user names in SA.
User names should:

A B C D E F G H I J K L M N O P Q R S T U V W X Y Z a b c d e f g h i j k l m n o p q r s t u v w x y z 0 1 2 3 4 5 6 7 8 9 . _

Upgrades

This section lists the tasks that should be performed after you upgrade to SA 10.20.

SA Cores

If your SA Core matches one of the SA Core configurations supported for customer upgrade and described in Chapter 2: SA Core Configurations in the  SA 10.20 Installation Guide, you can upgrade from a previous SA version to SA 10.20 yourself. However, if your core does not match any of these SA Core configurations, your first SA Core upgrade to SA 10.20 from a previous version must be performed by HP Professional Services or an HP certified consultant.

After the core has been upgraded to SA 10.0, HP supports customer-performed upgrades to SA 10.x or later as long as your core configuration is one of the supported configurations. All other core configurations will continue to require the services of HP Professional Services. If you are uncertain whether you can upgrade an existing SA Core yourself, contact HP Technical Support.

Perform the Required Upgrade on all SA Agents

After you upgrade to SA 10.20, you should also upgrade to the 10.20 SA Agents on each Managed Server in the facility. If you do not upgrade your agents, the new functionality will not be available.

Additionally, SA 10.20 no longer supports SA Agents associated with SA 9.10 or earlier versions. Therefore, at a minimum, any SA Agents with version 9.10 or earlier must be upgraded to an SA Agent that is version 9.11 or later. 

See the Upgrade Guide for instructions on upgrading your SA Agents.

Reapply your Customized Settings

If you have customized such settings as Java heap settings, you must reapply your customizations after you install SA 10.20, as the settings are set to the SA default during installation or upgrade.

For more information on upgrade, see the Upgrade Guide.

 

Back to the Table of Contents


Known Issues

This section describes known issues for SA 10.20. The tables list issues first alphabetically by Subsystem, then numerically within each subsystem.

Note: The Server Automation-Executive Scorecard (SA-XS) integration does not support a configuration with XS 9.5 and SA 10.20. See XS documentation for details.

Known Issues

QCCR1D Symptom/Description Platform Workaround
Agent Deployment/Upgrade Backend
188812 When an IPv6 gateway is used to install agent AIX server, the server is managed as IPv4 address.
Independent This request is caused by the product running in an unsupported configuration. Change to a documented and supported configuration. If the problem still exists in a supported environment, contact HP Support.
193047 AgentCache is not refreshed immediately after primary core upgrade, so if you try to deploy agents using the scan and deployment tool from the SA primary core, older agents might be deployed. AgentCache has s scheduled refresh every 8 hours. Independent

Wait for the agentcache refresh that happens every 8 hours, or manualy refresh the agentcache:

  1. Log in to every slice server from the primary core as root.
  2. Run: /etc/init.d/opsware-sas restart agentcache.
193587 In some scenarios and network topologies, when scanning for an IPv6 enabled server, the SSH port is shown as unavailable and the agent cannot be deployed. Independent From the SA Client, modify the ADT scanning parameters based on the network topology, proxy, and firewall rules.

If you encounter issues in scanning unmanaged servers with  ADT on IPv6, in the SA Client, access Tools > Options > SA Agent Installation > Advanced, and remove "-S %GATEWAY_IP% --exclude %GATEWAY_IP%" from the scan parameters.
Agent Deployment/Upgrade UI
192728 When using the ADT Scan feature, an nmap (the tool used to make the network map) error will be displayed in the SA Client when scanning ranges using an asterisk (*) or /24 (CIDR) notations.  Independent None.
Audit & Compliance Backend
162962 When you export audit results to XML, the results will not be correctly displayed if they include text that has an accented character. The following error appears in the results:

XML page cannot be displayed. Invalid character was found in text content.
Independent None.
165732 Running a snapshot-based audit with multiple Perform Inventory rules will result in the following RuntimeException error:

Multiple Inventory checks are not supported for snapshot-based audit. Optionally, run the corresponding rule types with (*) option.
Independent Run the snapshot-based audit for corresponding rule types with the (*) option instead of the Perform Inventory option enabled.
Audit & Compliance UI
151552 If you cancel a running audit job, and a target server shows a "SKIPPED" job status in the audit results, until an audit has successfully run, the server's compliance view shows the following incorrect status for the policy:

“Policy has changed since the last scan”.
Independent Rerun the Audit.
Certificate
184908 Occasionally, core recert status will show core recert session not in progress, even though core recert has been executed. May be most applicable if you have a system that is FIPS-enabled. Linux This may be related to a timing issue. Generally waiting 10 minutes or so seems to resolve the problem.
189612 When core recert is run to recert with a custom certificate, the clean up process does not clean up /var/opt/opsware/crypto/<components>/crypto.<session no> subdirectories.

For example: /var/opt/opsware/crypto/twist/crypto.0 for twist component and recert session 0

These directories contain the original certificates and are not removed by the core recert process. They were intended as a way to review prior certificates that were in use prior to core recert.
Linux These directories can be manually removed.
189765 Upon completion of core recert original gateway certificates may remain in /var/opt/opsware/crypto/recert Linux  This directory may be manually removed.
189893 After core recert infrastructure-only (non-slice) boxes will not have the proper certificates for the word_upload component and work_upload may not work properly on that box. Linux May be resolved manually by copying certificates in /var/opt/opsware/crypto/word_uploads on box with slice to the corresponding directory on the infrastructure-only box.
191641 On a FIPS-enabled core, job stops at Core Recert phase 7. Linux

Run phase 7 again.

192667 If you are using core recert that are either already FIPS-enabled or that are enabling FIPS using core recert, core recert will not execute. A stack trace as follows will appear in the waybot.err log.

[18/Nov/2014 17:14:36 +0000] ERROR "poke_handler(), id 3340001:

 Traceback (most recent call last):

  File "/opt/opsware/waybot/base/deliverance.py", line 1287, in poke_handler

    reply = server.poke( args )

  File "./xmlrpc/xmlrpclib.py", line 830, in __call__

  File "./xmlrpc/lcxmlrpclib.py", line 130, in __request

 ...
WriteError: Socket write error: (336031996L, 'unknown protocol')

Linux Use the SA Client to run a communication test on the managed server associated with the primary core.
193343 During testing it was noticed that for standalone OSPROV boxes, the certificate /var/opt/opsware/crypto/coglib/opsware-ca.crt contains the old certificate and is not cleaned up/. Linux The file can be manually edited and the old certificate removed.
193346 Affects you if you use custom certificates. The problem does not affect the proper functioning of the system. For non-slice boxes (infracstrure-only box, osprov-only box, or satellite) the opsware-ca.crt and agent-ca.crt in /var/opt/opsware/crypto/oi has both the old and new certificate. This is a cleanup issues only.
Linux Hand-edit the certificates and remove the old certificates.
APX
111925 Configuration file installation requires that destination directory exists.

A deployment that includes a configuration file component fails without any warnings or error when attempting to place a file in a directory that has not been created in advanced.

Independent Ensure that a code (or other type of ADM component) creates the destination directory in preparation for placement by the Configuration File component.
162834/165943 The following error is displayed when you run an OS build plan, and that build plan is started on a different facility to the one that its target uses:

"Failed to inject required settings.[Errno 2] No such file or directory: '/tmp/osbp_info/'"
Independent Due to a multimaster mesh limitation, you cannot start an OS Build plan on a target server that is attached to one core while connected to a different core.

Start the OS build plan from the same facility that contains its target. This ensures that the plan and its target are using the same database.

Back to the Table of Contents

QCCR1D Symptom/Description Platform Workaround
Gateway
193091 After upgrading core from SA 10.0 to SA 10.2, the 10.0 satellite becomes unreachable. Independent All SA Satellites and Cores must be upgraded together when upgrading SA from 10.0 and 10.01 to 10.2.
Installer
190859/190860 If a satellite facility is given a custom realm name (different from the name of the facility) then SA won't be able to determine the home core DC of the satellite which can lead to functional issues.

Way errors: Realm is currently unreachable. Cannot determine parent realm.
Independent Install the satellite realm with the default name (same as facility name)

Contact SA support for workaround steps if a satellite is already installed and not functioning.
Managed Platforms
191478 CentOS 7 Build Plan fails with TypeError after migration from SA 10.02 with platform installed to SA 10.2. Independent None.
Model Repository (Truth)
166334/188553

SA installed Oracle RDBMS modifies file /etc/sysconfig/selinux and inserts entry for SELINUX regardless of whether a previous entry exists.

SA installed Oracle RDBMS also inserts the following entry regardless of whether a previous entry exists:
 #SAS Oracle parameters begin
 SELINUX=disabled
 #SAS Oracle parameters end

Linux  If multiple entries exist, then keep the entry shown below, which is created by SA. Oracle (SQL*plus, OCI etc.) will not function properly if SELINUX is set to 'enforcing'. It is suggested that SELINUX be set to 'disabled' or 'permissive'.

 #SAS Oracle parameters begin
 SELINUX=disabled
 #SAS Oracle parameters end

191511 There is a connectivity issue from MM infra slice to the secondary core DB when secondary core's database is in a RAC configuration and that secondary RAC fails over to a second node.

Currently, a manual change to the MGW properties file and the tnsnames.ora files are needed to achieve a fail over.
Independent None.
OCC Client Framework (SA Web Client Framework)
191941/192463 The SA Client progress bars are reduced at a line and do not indicate progress for Windows R2.
Windows None.
OCC Web (SA Web Client)
135460 Not able to select servers in Run Custom Extensions submenus.
Independent None.
172654 Unable to start httpsProxy. SA installer should validate /etc/hosts against multiple 'localhost' definitions.

---------
# /etc/init.d/opsware-sas start httpsProxy
>>> Verify httpsProxy dependencies...
>>> Starting httpsProxy ...
httpsProxy: Starting httpsProxy on ports (80 81 82 4433)

[Thu Sep 19 14:11:13 2013] [warn] VirtualHost localhost:82 overlaps with VirtualHost localhost:82, the first has precedence, perhaps you need a NameVirtualHost directive

[Thu Sep 19 14:11:13 2013] [warn] VirtualHost localhost:81 overlaps with VirtualHost localhost:81, the first has precedence, perhaps you need a NameVirtualHost directive

(98)Address already in use: make_sock: could not bind to address 127.0.0.1:81
no listening sockets available, shutting down.
Linux In the /etc/hosts file, remove 'localhost' and 'localhost.localdomain' from the definition line that begins with ::1. Save the file, and retry the installer.
 
OCLI (Command-Line Interface)
191551

Clients upgrading from a release prior to SA 10.10 will not have access to the new version of OCLI unless the SA user belongs to one of the following groups: "Software Deployers", "Software Policy Setters", or "Superusers".

Independent Grant needed permissions on the /Opsware/Tools/Ocli folder in SA in order to successfully use the latest version of OCLI.
192256 OCLI oupload command fails when using option "--old" if the Agent is in a Satellite facility. Independent Use this option only when not behind an SA Satellite. Otherwise it will fail.

Back to the Table of Contents

QCCR1D Symptom/Description Platform Workaround
OS Provisioning
114523 OS Sequences can fail with persistence error when sequence includes a device group and is run repeatedly. Independent None.
160047 Running an OS Build Plan on a device created in a facility different than the one it will be in when reaching Maintenance mode might fail.

Independent

Create the device record with the correct Facility (that is, the facility that the server will register with when reaching maintenance mode).

Use the Manage Boot Client extension to configure the OS Build Plan to start automatically when the server reaches maintenance mode.

175069 Cannot use an OS Build Plan to provision Windows Server 2012 to a UEFI ProLiant server's second hard disk unless both of the server's hard disks are empty. Independent Ensure that all data has been removed from both hard disks then retry the provisioning.
176162 When using the RHEL 6.5 service OS, SCVMM 64-bit OSBPs should work with the 64-bit OGFS agent option. However, Hyper-V fails to boot into maintenance. This issue is related to a known RedHat defect:

https://bugzilla.redhat.com/show_bug.cgi?id=923184
Independent Use PXE-less provisioning.
184918 OSBP Windows and Linux Deployments sometimes fail with rosh error code 249. Linux;Windows

To apply the workaround, enter the following on each core:

  1. /etc/init.d/opsware-sas stop opswgw-mgw opswgw-cgws opswgw-agws
  2. cd /etc/opt/opsware/opswgw-agws1-<facility_name>
  3. mv opswgw.custom opswgw.custom.org
  4. echo "opswgw.PreConnectRetries=3" >> opswgw.custom
  5. /etc/init.d/opsware-sas start opswgw-mgw opswgw-cgws opswgw-agws

To rollback the workaround:

  1. /etc/init.d/opsware-sas stop opswgw-mgw opswgw-cgws opswgw-agws
  2. cd /etc/opt/opsware/opswgw-agws1-<facility_name>
  3. mv opswgw.custom.org opswgw.custom
  4. /etc/init.d/opsware-sas start opswgw-mgw opswgw-cgws opswgw-agws

189391

Ubuntu PXE-less provisioning  fails for servers hosted on SCVMM (System Center Virtual Machine Manager). Independent

Add the following command to the pressed:

d-i preseed/late_command string in-target apt-get -y remove irqbalance

193177

Autoregistration fails on WINPE32-OGFS at 'Wait for SA Agent to Start' step. Windows

1. Select Unprovisioned Servers > Add the iLO Device.
2. PXE boot the ProLiant server through WINPE32-OGFS.
3. After the server reaches Maintenance Mode, run the following command:
bs_ogfsagent_hw.bat

Upon completion of these steps, the server will be ready for provisioning.

Patch Management Backend
102713 From an overall compliance perspective, SA is reporting the correct color. It just doesn't report the same number of patches before and after the scan. This is controlled by how Microsoft reports applicable/installed patches.
Independent None.
137915/153979 Import of Solaris Patch Supplement content may render a false failure error on Fujitsu servers that are missing the appropriate Fujitsu credentials in the solpatch_import.conf file.

Sample error:

live-network-connector:ERROR : Import of content Solaris Patch Supplement version 2.00.00-01 failed. Exception: [PostExecuteError] Non-zero exit (6) for post-execute command '/tmp/tmpgcTtsa/install.sh'.
...
File "modules/lnc_common/ContentType.py", line 111, in do_post_execute
Solaris You can usually ignore this error unless you are trying to import metadata for Fujitsu patches.

 If you are trying to import metadata for Fujitsu patches, then you need to enter the Fujitsu credentials into the solpatch_import.conf file located at: /etc/opt/opsware/solpatch_import/solpatch_import.conf. Once the credentials are entered, this error message will go away.
146902/157891 Solaris 11 Patch policies should prevent the user from changing the reboot option to something other than the default option: 'Hold all server reboots until all actions are complete.'
Solaris Always ensure that the reboot option is 'Hold all server reboots until all actions are complete.' when remediating Solaris 11 Patch Policies.
151092 Duplicates between HPLN Patches and WSUSSCN2.CAB Patches. You have to run scripts that deletes one of the conflicting patches from the SA database. Independent A Hotfix is available through HP Support.
161961

The windows 2008 R2 SP1 consists of 2 binaries. When the user selects binary with file name windows6.1-KB976932-X64.exe and clicks uninstall in actuality the file gets uninstall and the server reboots and is now on Windows 2008 R2 RTM but the job times out and fails.

Windows 2008 R2 No workaround. Problem corrects itself with next scan.
162337 Windows 2k12 software policy remediation fails with the following type of error:

'AGENT_ERROR_PATCH_DATABASE_CERTIFICATE_ERROR'
Windows 2012;Windows 2012 R2 Import and run the latest (later than October 2012) Microsoft patch CAB file once. You should only have to do this one time.
184160 When a large number of policy items (and rpms) attached to a device group with a number of RHEL managed servers, even if a subset of rpms in the policy will be remediated or being used during Linux Patching, the App Compliance phase will still go through all the attached policies/rpms with insert/delete happening in the COMPLIANCE_DETAILS, which will be further inserted into the LCREP tables for replication.
Independent Create targeted software policies.

Monitor the Oracle tablespaces.
186135

Data Integrity Checker will show "FAILED" status "Missing In-Use Packages" check if any of the Ubuntu debian packages are not uploaded to the Software Repository.

Ubuntu This does not represent a problem. The packages can be uploaded to the software repository and the integrity checker will show "OK" after successful upload of the packages. The packages can be imported from vendor for file via the UI or by running the server script "Import Ubuntu packages".
187887/188563 Solpatch_import does nothing when a Solaris 11 server is specified and policy creation fails with no applicable policies.
Solaris Import all available package versions from the remote repository using the --all_versions switch.
For Solaris IPS Package importer script , "--all_version option is available to import all packages if you are unable to generate recommended packages using the default package import option".
Patch Management UI
156610/159052 A failure occurs during the remediation because all agent reboots are not held to the end. Instead the agent is rebooted as required by the software(patch) being installed. The point of failure is a patch that is being installed while the reboot is being done for the patch prior to it that requested a reboot. Independent None.

Back to the Table of Contents

QCCR1D Symptom/Description Platform Workaround
Search
92244 Searching on extended ASCII (i.e. words containing the "ß") characters returns no matching results.
Independent None.
SAV (Server Automation Visualizer)
181473 SAV does not show IPv6 INET addresses or IP  address for loopback in IPV6 format. Independent None.
Server Management
179140 Scheduling remediation job fails when customer tries to schedule a job for a static device group of 240 servers. The remediation job is not created.

The following error is visible in the twist.log:

#### <sho-p-hpsapp-01.company.com> <[ACTIVE] ExecuteThread: '22' for queue: 'weblogic.kernel.Default (self-tuning)'> <> <> <> <[STUCK] ExecuteThread: '17' for queue: 'weblogic.kernel.Default (self-tuning)' has been busy for "719" seconds working on the request "com.opsware._gen.sejb.swmgmt.SoftwarePolicyService_hfpabb_EOImpl", which is more than the configured time (StuckThreadMaxTime) of "600" seconds.
Linux None.
Server Module Backend (SMO)
156389 Users and Groups SMO will not report all the groups that are created on a Windows 2012 Essentials. If user properties are edited, these changes will not be reported by the SMO. This means that audits with U&G rules will not be relevant on a Windows 2012 Essentials. Independent None.
193063 When running the smtool upload command to upgrade a server module, the upgrade sometimes fails with this error:
'Upgrading /tmp/OPSWsmo_patches_packages-60.0.54409.0.zip
Traceback (most recent call last):
File "/opt/opsware/smtool/smtool", line 12, in <module>
smtool.smtool (sys.argv)
 ...
OSError: [Errno 2] No such file or directory: '/var/tmp/smtool.22996'
Independent None.
Software Management Backend
159841 When performing a core upgrade, you might experience conflicts originating from the UNITS and REALM_UNITS tables.  Independent In order to continue with the upgrade process, either manually resolve the conflicts or clear them using the force resolver script.
179479/179480 The  tokens used  by  recurring application  configuration  compliance compliance  jobs stop working because they have  a limited lifetime of  one year.
Independent Recreate the job.
188216

SA cannot be used to install/uninstall rpms that have a non-zero epoch on SLES 11 GA servers because the native tool used (zypper) does not support specifying a non-zero epoch for a package in an install or remove command.

SLES 11 GA

Upgrade zypper or use packages that have a zero epoch.
189432

Issuing the removal of server attachment for a large software policy may fail after the 5 minute timeout.

Independent Use the Remove server attachment feature on smaller groups of servers.
189493 If, on a CentOS7 server, only the 'core' package group was installed (typical in a Minimal Installation), it is possible that the required libxml2-python library is not installed, and the remediation with the native yum will fail. CentOs Manually install the libxml2-python library.
191279

The exit code for the yum shell (which is used by yum plugin) is 0 (zero), whether or not the install commands executed "inside" yum shell were successful. As a consequence, for failed installations or uinstallations, the Job Status will be "Warning" instead of "Failed".

Independent None.
After careful consideration regrettably HP has determined the requested change will not be addressed within the product.
       
Software Management UI
185123 The SA Client does not prevent attaching a policy of one customer to a device of another customer. This issue has no security impact since the units that have no matching customer are filtered out at runtime.
Linux None.
163518

"End Job" button is still enabled after the job has completed.

Independent None.
UCMDB
194366 The data from SA is not loaded correctly and completely when uCMDB server is configured in multi-tenancy mode. Independent None.
Vault (Model Repository Multimaster Component)
189533 RUP - MM conflicts in ROLE_CLASSES table are generated when Importing Windows Patch DB on lower schema core. Independent After careful consideration regrettably HP has determined the requested change will not be addressed within the product. 
Virtualization Backend
183608 The Openstack VM server is reachable externally only through its public floating IP, not through its internal private IP.

The SA Agent is installed on the server using its floating IP, so eventually the management IP of the server is set to its floating IP.

The server’s operating system is not aware of the floating IP, so the SA Agent is unable to gather this information. As a result, the server's floating IP is not present in the interface list for this server nor in the Management IP drop-down list on the server's Network view.

Do not try to change the IP from its “Default” setting to the internal OpenStack IP.
Independent None.
Virtualization Backend vCenter
141907 If you configured the number of cores per socket using the native vSphere client, and modify the number of virtual processors with a Modify VM job in SA, the CPUs might end up in an invalid configuration. When you edit the CPU settings in the native vSphere client, this error, “Number of cores per socket cannot be greater than number of virtual CPUs” occurs when the configuration is invalid.

The native vSphere client multiplies the number of virtual sockets by the number of cores per socket to determine the Total CPUs. SA only discovers and sets the Total CPUs (from the Virtual Processors field). Examples when the VM has 2 cores per socket:

Set SA’s Virtual Processors to 8, there will be 4 virtual sockets and 8 total CPUs.

Set SA’s Virtual Processors to 1, the number of virtual sockets will be 1 and that results in an invalid configuration.
VMware If the number of cores per socket for a VM is greater than 1, and you want to modify the CPUs:



From SA, set the number of Virtual Processors as a strong multiple of the number of cores per socket.

Or, use the native vSphere client to modify the CPUs.
158199 Virtual distributed switches cannot be discovered using the VMware virtualization service. As a result, a virtual machine's NIC connections to virtual distributed switches will not be visible in the SA Client or in backend objects.
VMware None.
Virtualization - HPUX (HPVM Front end)
157368/160408 Search with IP Address or Hostnames on Add Virtual Server screen does not list HP-UX machines. This issue is noticed for machines with vpar & hpvm software installed.
Independent Servers can still be listed when "All" is selected on the Add Virtual Server screen.
Virtualization - HPUX (vPars Front end Front end)
132471 Improve error message text.
Independent None.
Virtualization UI
160891

If a Create VM, Clone VM, or Deploy VM from VM Template job fails when running the OSBP, and the VM ends up in a Build Server Failed state, the VM cannot be deleted from SA Client

Independent Delete the VM from native vendor tool and reload in SA.
Workload Manager
166350 Jobs remain with a status of Active, even though their associated tasks show a status of Success.

This known issue is applicable only to Workload Manager framework-based jobs, such as V12n or iLO.
Independent This issue occurs only in multi-core mesh installations where the SA Jobs are being approved using Operations Orchestration on all the cores of the mesh. To work around this issue, setup OO workflow only on the primary core of the
mesh.

Back to the Table of Contents


Third-Party Known Issues

QCCR1D Symptom/Description Platform Workaround
Compatibility Matrix
184778 The Linux IA64 platform does not provide cores/sockets information thus we can't display CPU information for this platform. Linux None.
184782 The HP-UX PA-RISC platform does not provide cores/sockets information thus we can't display CPU information for this platform. HP-UX None.
ISM Tool
184338 When uninstalling an ismtool-created policy, the application's pre/post-uninstall scripts that call the control scripts can't run because the control package was removed before the application. This is a known issue for rpm, which doesn't respect the dependency order at uninstall time. It was fixed with rpm version 4.4.6. Independent As a workaround, you can upgrade the rpm tool to a newer version (at least 4.4.6) or, if you want to do it manually, try to reverse the order of packages.
Software Management Backend
171076 Packages that are recommended by other packages that are going to be installed will not be removed when detaching a software policy. Ubuntu None.
171553 Downgrading DEB packages leaves package conflicts. Ubuntu None.
181556 If a user installs packages that have circular dependencies then he should not add different flags to the install command for any of the packages.

Ideally the user should not add any flag at all. If by mistake this happens, the install will fail and the system will be left in a broken state.

In order to fix this a script containing the following line should be run as root: "apt-get -f -y install.
Ubuntu After careful consideration regrettably HP has determined the requested change will not be addressed within the product.

Back to the Table of Contents


Fixed Issues

The Fixed Issues table includes issues that:

The table lists issues first by subsystem, then numerically within each subsystem.

QCCR1D Symptom/Description Platform
Agent
134334/136808 One gateway node in a realm with multiple gateway nodes will be receiving a disproportional number of agent -> core ingress connections. Independent
183515/191556 OS provisioning jobs intermittently fail at HPSA agent installation step due to rc: 2560 error.
Linux
185253/186002 SA Agent installation fails on AIX 7.1 if the system locale is Japanese (LANG=Ja_JP). AIX
191459/191460 Upgrade HPSA agents from 50.x to 55.x fails on systems that contain "libeay32.dll"  file under the C:/Windows/System32 directory. Windows
Agent Deployment/Upgrade UI
186955/187161 Deploying agents on Linux/Unix servers remotely using the SSH protocol fails if the server has SSH banner activated and the banner contains the '#' sign.
Linux
Audit and Compliance
186501/187585 Attempts to log in to  a particular Slice fail with

Exception:   com.opsware.rmi.SpokeConnectionException

Spoke connection failed.

Scheduled jobs fails to run and Authentication errors seen in spoke logs while the problem is occurring.
Linux
187751/188430 When performing audits on multiple servers (23)., the following error appears in the job report for about 10 servers:

"HPSA-1511 : A Web Services Data Access Engine (twist) method was called incorrectly. The application returned the displayed message.

...
'module': '', 'faultCode': 101, 'params': {}, 'line': -1, 'method': ''}]

script.global_soft_cancel_dict {}
Linux
189972 HPLN-connector should not expose username and password credentials when it imports content into Server Automation. Independent
APX
189127/190392

Agent could not be installed on a VM that was cloned, and was prepared with cloning APX. A race condition was detected, caused by the network setup running in parallel with agent install. A delay of 5 minutes was added for the automatic agent install in the task scheduler.

Windows
Gateway (SA Gateway)
186115/189177 During high activity periods tcp flows proxied over the SA gateway mesh may hang causing unexpected delays or failures in carrying out operations. Heavy OO-SA usage was observed to trigger this condition but it may occur sporadically without OO integration as well. Independent
Installation (OI)
183786 The installer may copy tnsnames.ora to the DB server. Creating and changing tnsnames.ora  on the custom-installed remote database server may result in unexpected behavior.
Linux
190924 If /var/tmp/pylibs_backup/pylibs2 exists, then the upgrade from a pre 10.10 version of SA fails with below error:

--------

Verifying dependencies

Verify truth.dcId: SUCCESS

Verify Oracle home directory: SUCCESS

Verify "/var/opt/oracle/tnsnames.ora" exists: SUCCESS

Verify hostname <servername> is listening on port 14540: SUCCESS

Verify user "opsware_admin" can connect to database "hpsadev": FAILURE (Error while trying to retrieve text for error ORA-01804

---------
Linux
191264 The Oracle password is not quoted correctly and is causing add_dc_to_mesh to fail.

The following script is hanging: /bin/sh /var/tmp/hpsa_media/opsware_installer/tools/calculate_export_size.sh /apps01/oracle/11.2.0 SID PASSWORD TNSNAME.
Linux
192472 Upgrade of the Repository using the Agents and Tools (Upload) ISO fails with the following error:

com.opsware.common.UniqueNameException: ID: HPSA-007

Code: com.opsware.common.MessageSpec.UNIQUE_NAME_ERROR

Details: This object requires a unique name and/or short name. Enter unique values to continue.
Linux
193042/193369 Free disk space necessary to export the database for a second core in a mesh is calculated incorrectly for the /var mountpoint instead of /var/tmp.
Linux
Jobs
185038/186884 The output for script jobs executed on the managed servers is not properly formatted when generating CSV reports.

If the script output contains more than one line then it will not be displayed correctly when opening the CSV report with a spreadsheet application like Microsoft Excel. Instead of being displayed into a single cell, it will span over multiple lines in the spreadsheet.
Linux
188399/188402 Consolidated CSV export of script results adds trailing newline into quoted output field.

If you try to import this CSV file into Excel, it won't import the Output field correctly due to this newline character being embedded.
Linux
OGFS/OGSH (Hub)
190679/190680 Bash vulnerabilities CVE-2014-7169, CVE-2014-6271 that allow remote attackers to execute arbitrary code through a crafted environment must be addressed with OGFS. Linux
OS Provisioning
183961/184619 When running MBC concurrently the program will fail with output similar to the output below:

Can't get lock after 30 seconds, giving up on reconfiguring DHCPd.  Perhaps the lock file (/etc/opt/opsware/dhcpd/mbc_adding_hosts_to_dhcpd_conf.lock) was created and never deleted, see your Opsware administrator to troubleshoot.Traceback (most recent call last):

File "/opsw/apx/runtime/script/osprov.manage_boot_clients_script/bin/import_boot_client_csv.py", line 70,
...
OSError: [Errno 17] File exists: '/home/username/.mbc/123523643.6'
Independent
184355/184356 TMBC configuration resets the dhcpd server which can cause PXE boot failures for multiple concurrent builds.
Independent
188842/189133 Twist error : ilo auto registration silently fails. There are two different transactions against devices table: one made by the Spin that updates a server record (agent registration) and the other one made by Twist to read the same record (iLO autoregistration). Twist always gets the old value of the server, even if the read operation is retried after 15 seconds. This was fixed by using a non-cached read operation. Independent
190284/190515
While running a Manage Boot Clients (MBC) job there is a step that does DHCP reconfiguration. If the reconfiguration of DHCP fails, the SA job appears as successful. The status of the MBC job should be failed.
Independent
Patch Management Backend
185871/185873 Getting following error while patching AIX 6.1 server.

Error Messages: An unexpected error has occurred. Contact your HP Server Automation Administrator.Traceback (most recent call last): File "/var/opt/opsware/waybot/scripts/opsware.swprov.doer~45.0.5", line 7214, in doitInstallUnitsFinish .
...
'get_greatest_satisfying_fileset'.
Independent
190753/190754 CBT imports failing with following message in wordbot.err:
----------
ERROR "ErrorName: spin.notFoundInDatabase
FaultCode: 4
Timestamp: 18/Sep/2014 130338
Request: UNKNOWN
Module: truthdb.py
Method: fetchUnique
Line: 823
Params: {'msg': "Record not found in table 'units': WHERE (unit_id = '-1')"}" - - - - ""
...
com.opsware.clients.impl.WordClient.upload(WordClient.java:153
    at ...
Independent
191519/191520 After importing the patch catalog from Microsoft, about 90% of the patches are grayed out although they have already been imported since last month.
Windows
191974/191974 The solpatch_import tool fails to import Solaris 10 patches with the error "SSL routines:SSL3_GET_RECORD:wrong version number". Independent
Patch Management UI
187191/187582 The following ORA-00913 error message is displayed while viewing Windows Server patches with Policies or Exceptions:
oracle.jdbc.driver.SQLStateMapping.newSQLException(SQLStateMapping.java:91)
...
at com.opsware.twist.utils.SQLHelper.execDbQuery(SQLHelper.java:332)
...
at weblogic.ejb.container.internal.SessionRemoteMethodInvoker.invoke(SessionRemoteMethodInvoker.java:40)
...
at com.opsware.pkg.ejb.session.UnitServiceBean.getUnitRefs(UnitServiceBean.java:581)
...
at weblogic.rmi.internal.wls.WLSExecuteRequest.run(WLSExecuteRequest.java:118)
...
at weblogic.work.ExecuteThread.execute(ExecuteThread.java:256)
Linux
188110/188111 OS Sequences can fail with persistence error when sequence includes a device group and is run repeatedly. Windows

Back to the Table of Contents

QCCR1D Symptom/Description Platform
Scripts
163487/164275 Python script types are not supported on Unix servers. Unix
Server Management
188755/188758 Two RDP sessions to a Windows 2012 R2 managed server through HPSA causes the python.exe process to use 100% CPU (only with 9.16 agent; 9.14 agent works).
Independent
Software Management Backend
190742/190934 When a remediation is executed against a managed server, an application and/or patch compliance is executed against that device. If an error occurs inside of a service instance for a command, the full context for the error should be reported back to the session and logged to twist's log file as at least level WARNING.

Example of generic error message from session dump:
--------------
['OpswareError', {'timestamp': '2014-10-03 03:44:14.781', 'error_name':
'Compliance : App Compliance Failed.', 'hostname':                   
...
'messageKeyOrder': 'msg'}, 'line': 99, 'method': 'onCommand'}]        
Independent
Software Management Tools
192987 If you configure rhn_import to use proxy authentication it will still fail to download the packages with this error message:

Unexpected error: URLError: <urlopen error Tunnel connection failed: 407 Proxy Authentication Required>
Independent
193663/193666 If you run rhn_import the following error message will be displayed:

Unexpected error: httperror_seek_wrapper: HTTP Error 403: Forbidden
Independent
Software Repository (Word)
191652/191653 The "populate-opsware-upload-library" utility hangs during the wsusscn2.cab upload portion of the script. Independent
Web Services Data Access Engine (Twist)
188055/188068 After uploading a PatchBundle which contains a HPUX Product, in Java Web Start log console the error "com.opsware.pkg.hpux.PatchBundleRef cannot be cast to com.opsware.pkg.hpux.DepotRef " is seen.

Also the SA Client appears to stop updating for the windows.

Linux
190492/190660 Cannot log in to SA Client

Example of error in javaws*.log:
Sep 3, 2014 10:54:29 AM com.sun.corba.se.impl.legacy.connection.SocketFactoryConnectionImpl
WARNING: "IOP00410201: (COMM_FAILURE) Connection failure: socketType: IIOP_SSL_WLS; hostname:<servername>; port: 443"
...
ectFailure(Unknown Source)
Independent

Back to the Table of Contents


Documentation Information

This section discusses documentation information for this release.

Simplified Access to the Most Up-To-Date Documentation

All the latest Server Automation documentation for this release is available from the SA 10.x Documentation Library on the HP Software Support portal.

This portal requires that you register for an HP Passport and sign in. Use the SA Documentation Library to access any of the guides, release notes, support matrices, and white papers relevant to this release or to download the full documentation set as a bundle. The SA Documentation Library is updated in each release and whenever the release notes are updated or a new white paper is introduced.

A direct link to the SA Documentation Library is also provided on the SA Client Help Welcome Page. From the SA Client menu, select Help > Help Contents, Index and Search.

Note: You can always find the most up-to-date SA Documentation Library on the HP Software Support portal. This portal requires that you register for an HP Passport and sign in. After signing in, click the Search button and begin filtering documentation and knowledge documents using the filter panel. If you do not have an HP Passport, you will be given an opportunity to register for one from the login page.

How to Find Information Resources

This section includes a list of technical information resources for each product.

To access the information resources for the included products, use any of the following methods:

To access individual documents:

  1. Go to the  SA 10.x Documentation Library.

    Note: A direct link to the SA Documentation Library is also provided on the SA Client Help Welcome Page. From the SA Client menu, select Help > Help Contents, Index and Search.

  2. Log in using your HP Passport credentials.
  3. Locate the document title you are looking for, and the version, and then click go.

To use the complete documentation set in a local directory:

  1. To download the complete documentation set to a local directory:
    1. From the the  SA 10.x Documentation Library.
    2. Log in using your HP Passport credentials.
    3. Locate the All Manuals Download title for the SA 10.20 version.
    4. Click the go link to download the ZIP file to a local directory.
    5. Unzip the file.
  2. To locate a document in the local directory, use the Documentation Catalog (docCatalog.html), which provides an indexed portal to the downloaded documents in your local directory.
  3. To search for a keyword across all documents in the documentation set:
    1. Open any PDF document in the local directory.
    2. Select Edit > Advanced Search (or Shift+Ctrl_F).
    3. Select the All PDF Documents option and browse for the local directory.
    4. Enter your keyword and click Search.

To find documents on the HP Software Support Portal:

  1. Go to https://softwaresupport.hp.com/
  2. Log in using your HP Passport credentials.
  3. Click Search.
    All available documentation appears listed in the content panel.
  4. Use the Filter panel to narrow the set of documents by Product, Version, Operating system, Document Type, Optional keyword(s) or phrases, and so on.
    All available documentation for the selected product release will be listed as download links with information about the document, such as publication date, modified date
  5. Identify your document in the list of documents.

Note: Some of guides and white papers, although released in earlier patches, are still relevant to this release. You will also receive updated or new editions if you subscribe to the appropriate product support service. Contact your HP sales representative for details. Note the Document Release Date on the title page of your guide and see the Documentation Change Notes on page 3 of most documents for a list of any revisions. The release-notes change table is at the bottom of this document.

Back to the Table of Contents


HP Software Support

This web site provides contact information and details about the products, services, and support that HP Software offers. For more information, visit the HP Support web site at: HP Software Support Online.

HP Software support provides customer self-solve capabilities. It provides a fast and efficient way to access interactive technical support tools needed to manage your business.

As a valued support customer, you can benefit by being able to:

To access the Self-Solve knowledge base, click Search. Use the filter panel to search for knowledge documents, product manuals, patches, or any kind of available documentation type.

Note: Most of the support areas require that you register as an HP Passport user and sign in. Many also require an active support contract. To find more information about support access levels, go to: Access Levels. If you do not have an HP Passport, you will be given an opportunity to register for one from the login page.


Legal Notices

Warranty

The only warranties for HP products and services are set forth in the express warranty statements accompanying such products and services. Nothing herein should be construed as constituting an additional warranty. HP shall not be liable for technical or editorial errors or omissions contained herein. The information contained herein is subject to change without notice.

Restricted Rights Legend

Confidential computer software. Valid license from HP required for possession, use or copying. Consistent with FAR 12.211 and 12.212, Commercial Computer Software, Computer Software Documentation, and Technical Data for Commercial Items are licensed to the U.S. Government under vendor's standard commercial license.

Copyright Notices

© Copyright 2000-2014 Hewlett-Packard Development Company, L.P.

Trademark Notices

Adobe® is a trademark of Adobe Systems Incorporated.
Intel® and Itanium® are trademarks of Intel Corporation in the U.S. and other countries.
Microsoft®, Windows®‚ Windows® XP are U.S. registered trademarks of Microsoft Corporation.
Oracle and Java are registered trademarks of Oracle and/or its affiliates.
UNIX® is a registered trademark of The Open Group.

Release-Notes Updates

New Publication Date Change
   
   
   

To check for recent updates or to verify that you are using the most recent edition of a document, go to:
 SA 10.x Documentation Library.

You will receive updated or new editions if you subscribe to the appropriate product support service. Contact your HP sales representative for details.

Back to the Table of Contents